// ClassDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VisualClassBuilder.h"
#include "ClassDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClassDlg dialog


CClassDlg::CClassDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClassDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClassDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	// Init members
	_tcscpy(m_lpszClassName, _T(""));
	_tcscpy(m_lpszClassHeaderFile, _T(""));
	_tcscpy(m_lpszClassImplementationFile, _T(""));
	_tcscpy(m_lpszAuthor, _T(""));
	_tcscpy(m_lpszDescription, _T(""));
	m_pVariableList = NULL;
	m_iVariableNumber = 0;
	m_pMethodList = NULL;
	m_iMethodNumber = 0;
	m_pParentList = NULL;
	m_iParentNumber = 0;
	m_pClassList = NULL;
	m_iClassNumber = 0;
	m_bMFCHeaders = FALSE;
	m_bComments = TRUE;
}


void CClassDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClassDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClassDlg, CDialog)
	//{{AFX_MSG_MAP(CClassDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClassDlg message handlers

BOOL CClassDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Add class dialog property pages
	m_Sheet.AddPage(&m_Options1);
	m_Sheet.AddPage(&m_Options2);
	m_Sheet.AddPage(&m_Options3);
	m_Sheet.AddPage(&m_Options4);
	m_Sheet.Create(this, WS_CHILD | WS_VISIBLE, 0);
	m_Sheet.ModifyStyleEx(0, WS_EX_CONTROLPARENT);
	m_Sheet.ModifyStyleEx(0, WS_TABSTOP);
	m_Sheet.SetWindowPos(NULL, 35, 20, 500, 280, SWP_NOZORDER | SWP_NOACTIVATE);

	// Set class options_1 params
	m_Options1.m_ClassName = m_lpszClassName;
	m_Options1.m_HeaderFile = m_lpszClassHeaderFile;
	m_Options1.m_ImplementationFile = m_lpszClassImplementationFile;
	m_Options1.m_Author = m_lpszAuthor;
	m_Options1.m_Description = m_lpszDescription;

	// Set class options_2 params
	m_Options2.m_iVariableNumber = m_iVariableNumber;
	m_Options2.m_pVariableList = m_pVariableList;

	// Set class options_3 params
	m_Options3.m_iMethodNumber = m_iMethodNumber;
	m_Options3.m_pMethodList = m_pMethodList;

	// Set class options_4 params
	m_Options4.m_iParentNumber = m_iParentNumber;
	m_Options4.m_pParentList = m_pParentList;
	m_Options4.m_pClassList = m_pClassList;
	m_Options4.m_iClassNumber = m_iClassNumber;
	m_Options4.m_bMFCHeaders = m_bMFCHeaders;
	m_Options4.m_bComments = m_bComments;

	// Check for active property page
	switch (m_Sheet.GetActiveIndex())
	{
		case 0:
		{
			m_Options1.UpdateData(FALSE);
		}
		break;

		case 1:
		{
			m_Options2.UpdateData(FALSE);
		}
		break;

		case 2:
		{
			m_Options3.UpdateData(FALSE);
		}
		break;

		case 3:
		{
			m_Options4.UpdateData(FALSE);
		}
		break;
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CClassDlg::OnOK() 
{
	// Check for active property page
	switch (m_Sheet.GetActiveIndex())
	{
		case 0:
		{
			m_Options1.UpdateData(TRUE);
		}
		break;

		case 1:
		{
			m_Options2.UpdateData(TRUE);
		}
		break;

		case 2:
		{
			m_Options3.UpdateData(TRUE);
		}
		break;

		case 3:
		{
			m_Options4.UpdateData(TRUE);
		}
		break;
	}

	// Get class options_1 params
	_tcscpy(m_lpszClassName, m_Options1.m_ClassName);
	_tcscpy(m_lpszClassHeaderFile, m_Options1.m_HeaderFile);
	_tcscpy(m_lpszClassImplementationFile, m_Options1.m_ImplementationFile);
	_tcscpy(m_lpszAuthor, m_Options1.m_Author);
	_tcscpy(m_lpszDescription, m_Options1.m_Description);

	// Get class options_2 params
	m_iVariableNumber = m_Options2.m_iVariableNumber;
	m_pVariableList = m_Options2.m_pVariableList;

	// Get class options_3 params
	m_iMethodNumber = m_Options3.m_iMethodNumber;
	m_pMethodList = m_Options3.m_pMethodList;

	// Get class options_4 params
	m_pParentList = m_Options4.m_pParentList;
	m_iParentNumber = m_Options4.m_iParentNumber;
	m_bMFCHeaders = m_Options4.m_bMFCHeaders;
	m_bComments = m_Options4.m_bComments;
	
	CDialog::OnOK();
}
